program main

  use vtype_module
  use fi_module


  use constants0, only : PI

  use rad_planetconst, only : &
    & RadPlanetConstInit, &
    & Grav,            &
    & Cp,              &
    & MolWtNonRadAct

  use gauss_quad, only : GauLeg

  use sortac_module, only : sortac

  use hitranconst, only : m_HITRANMolWt

  use io_profile, only : &
    & IOProfileInqDimLen, &
    & IOProfileRead, &
    & IOProfileReadPtcl

  use ave_optprop_particle, only : AveOptPropParticle

  use main_output, only : CalcAndOutputFlux, EstimateError

  implicit none


  logical, parameter :: FlagCalcLBL = .true.

  character(stdstr) :: CtlFN0 = 'planetconst.conf'
  real(DP)          :: GravSet
  real(DP)          :: CpSet
  real(DP)          :: MolWtNonRadActSet

  character(128) :: CtlFN  = 'sort_ac.conf'
  character(128) :: CtlFN2 = 'sort_ac_file.conf'
  character(128) :: CtlFN3 = 'calc_rte.conf'
  character(128) :: CtlFN4 = 'sort_ac_atm.conf'

  integer :: FileUnit
  integer :: FileUnitQL
  integer :: iostat


  logical :: FlagChkConstVMR
  logical :: FlagKeyMolACAverage
  logical :: FlagNonKeyMolACAverage
  logical :: FlagPFRatioOne
  logical :: FlagSortPFRatioAverage

  integer, parameter :: MaxNmlArySize = 256
  real(8)            :: WNBnds(MaxNmlArySize)
  integer            :: KeyMolNum(MaxNmlArySize)

  integer              :: BandNBin
  integer              :: NKeyMol
  integer              :: NKeyMolExcept

  real(DP)             :: AveOptPropAtmTemp

  integer              :: NBand
  real(8), allocatable :: ab_BandWNBnds    (:,:)
  integer, allocatable :: a_BandNBin       (:)
  integer, allocatable :: ab_BandKeyMolNum (:,:)

  integer, allocatable :: cb_BandGaussRegNBin (:,:)
  integer              :: iGaussReg

  integer              :: NBandCur = 1
  real(8), allocatable :: ab_BandCurWNBnds    (:,:)
  integer, allocatable :: a_BandCurNBin       (:)
  integer, allocatable :: cb_BandCurGaussRegNBin(:,:)
  integer, allocatable :: ab_BandCurKeyMolNum (:,:)

  integer :: n


  ! 設定変数, 他
  ! setteing parameter, values
  !
  character(256) :: InOrgOptPropNcFN
                          ! 
                          ! input file name for original optical properties
  character(256) :: InOrgStrSpeNcFN
  character(256*2) :: InOrgPtclOptPropNcFN
  character(256*2) :: InPtclOptPropNcFN

  character(256) :: OutDir
  logical        :: FlagOutSpeFlux
  character(256) :: OutSpeFluxNcFN
  character(256) :: OutOptPropGasNcFN
  character(256) :: OutOptPropPtclNcFN
  character(256) :: OutFluxNcFN
  character(256) :: OutTendencyNcFN

  character(256) :: InProfNcFn

!!$  real(8) :: CentStarConst

!!$  real(8) :: InAngle
                          ! sec (太陽光入射角) [1]
                          ! sec (angle of incidence) [1]
!!$  real(8) :: SurfAlbedo
                          ! 地表面アルベド [1]
                          ! surface albedo [1]

  integer, allocatable :: m_MolNum(:)
  real(8), allocatable :: r_Press (:)
  real(8), allocatable :: r_Temp  (:)
  real(8), allocatable :: rm_VMR  (:,:)

  integer                            :: NPtcl
  integer              , allocatable :: a_PtclNum     (:)
  character(len=stdstr), allocatable :: a_PtclName    (:)
  real(8)              , allocatable :: a_PtclDens    (:)
  real(8)              , allocatable :: za_PtclDens   (:,:)
  real(8)              , allocatable :: za_PtclEffRad (:,:)
  real(8)              , allocatable :: za_PtclMMR    (:,:)
  real(8)              , allocatable :: za_DelPtclMass(:,:)

  real(DP)              :: StrFluxTOA

  real(DP) :: AlbedoSW
  real(DP) :: AlbedoLW
  real(DP) :: EmisSW
  real(DP) :: EmisLW
  real(DP) :: WaveNumAlbedoSwitch

  integer  :: NGQ
  real(DP) :: SZADeg
  real(DP), allocatable :: a_GQMu    (:)
  real(DP), allocatable :: a_GQWeight(:)

  integer               :: NGQLoop
  real(DP), allocatable :: s_SZADeg(:)

  character(256) :: StrSpeNcFN

  real(DP) :: WNIntegStart
  real(DP) :: WNIntegEnd
  real(DP) :: WNIntegStartSave
  real(DP) :: WNIntegEndSave

  real(8), allocatable :: r_MeanMolWt(:)
  real(8), allocatable :: r_VMRNonRadAct(:)

  real(8), allocatable :: z_Press(:)
  real(8)              :: SurfTemp


  real(8), allocatable :: r_RadUwFluxAllLBL(:)       ! upward flux
  real(8), allocatable :: r_RadDwFluxAllLBL(:)       ! downward flux
  real(8), allocatable :: r_RadUwFluxLWAllLBL(:)     ! upward flux
  real(8), allocatable :: r_RadDwFluxLWAllLBL(:)     ! downward flux
  real(8), allocatable :: r_RadUwFluxSWAllLBL(:)     ! upward flux
  real(8), allocatable :: r_RadDwFluxSWAllLBL(:)     ! downward flux

  real(8), allocatable :: r_RadUwFluxBandLBL(:)       ! upward flux
  real(8), allocatable :: r_RadDwFluxBandLBL(:)       ! downward flux
  real(8), allocatable :: r_RadUwFluxLWBandLBL(:)     ! upward flux
  real(8), allocatable :: r_RadDwFluxLWBandLBL(:)     ! downward flux
  real(8), allocatable :: r_RadUwFluxSWBandLBL(:)     ! upward flux
  real(8), allocatable :: r_RadDwFluxSWBandLBL(:)     ! downward flux

  real(8), allocatable :: z_DTempDt      (:)
                          ! tendency
  real(8), allocatable :: r_RadUwFlux    (:)
                          ! upward flux
  real(8), allocatable :: r_RadDwFlux    (:)
                          ! downward flux

  real(DP), allocatable :: z_DTempDtLW      (:)
  real(DP), allocatable :: r_RadUwFluxLW    (:)
  real(DP), allocatable :: r_RadDwFluxLW    (:)
  real(DP), allocatable :: z_DTempDtSW      (:)
  real(DP), allocatable :: r_RadUwFluxSW    (:)
  real(DP), allocatable :: r_RadDwFluxSW    (:)

  character(256) :: InNcFN
  character(256) :: InStrSpeNcFN
  character(256) :: OutGasNcFN
  character(256) :: OutPtclNcFN
  character(256) :: OutNcFN1
  character(256) :: OutNcFN2

  integer :: kmax
  integer :: NMol

  logical :: FlagSort
  logical :: FlagBinning
  logical :: FlagBinningDemonstration
  logical :: FlagCorrelation
  logical :: FlagKeyMolAbsOverlap

  integer              :: NGaussReg
  real(8), allocatable :: a_GaussRegBnds(:)
  real(8)              :: GaussRegBnds(MaxNmlArySize)

  integer              :: BandNum
  integer              :: GaussRegNBins(MaxNmlArySize)

  real(DP)       :: PressForPFSort

  character(128) :: Method

  integer :: iMode
  integer :: iBand

  integer :: iBands
  integer :: iBande
  integer :: iModes
  integer :: iModee

  integer :: k
  integer :: m
  integer :: iKeyMol



  namelist /planetconst_nml/ &
    & GravSet, CpSet, MolWtNonRadActSet
  namelist /band_mode_nml/ &
    & iBands, iBande, iModes, iModee
  namelist /flag_nml/ &
    & FlagChkConstVMR
  namelist /sort_file_nml/ &
    & InProfNcFn, &
    & InOrgOptPropNcFN, &
    & InOrgPtclOptPropNcFN, &
    & InOrgStrSpeNcFN, &          ! This is used for sorting, but is not used for flux calculation.
    & FlagOutSpeFlux, &
    & OutDir
  namelist /band_nml/ &
    & NBand, WNBnds, BandNBin, KeyMolNum
  namelist /band_exception_nml/ &
    & BandNum, GaussRegNBins, KeyMolNum
  namelist /rte_nml/ &
    & StrFluxTOA, &
    & StrSpeNcFN, &
    & AlbedoSW, &
    & AlbedoLW, &
    & WaveNumAlbedoSwitch, &
    & NGQ, &
    & SZADeg, &
    & WNIntegStart, &
    & WNIntegEnd

  namelist /gauss_region_nml/ &
    & NGaussReg, GaussRegBnds

  namelist /atm_nml/ &
    & AveOptPropAtmTemp

  WNIntegStart = -1.0d0
  WNIntegEnd   = -1.0d0

!!$  StrFluxTOA = 1370.0d0
  StrFluxTOA =    0.0d0
  StrSpeNcFN = 'solarflux.nc'
  AlbedoSW   = 0.2d0
  AlbedoLW   = 0.0d0
  WaveNumAlbedoSwitch = 3250.0d2
  NGQ        =    2
  SZADeg     =    0.0d0


  InProfNcFn           = ''
  InOrgPtclOptPropNcFN = ''

  InOrgStrSpeNcFN = "strspe.nc"

  FlagChkConstVMR      = .true.

  OutDir  = 'out'

  NBand = 1
  WNBnds    = -999.0d0
  WNBnds(1) = 0.0d0
  WNBnds(2) = 1.0d100
  KeyMolNum    = -1
  KeyMolNum(1) = 1
  BandNBin     = 1

  GaussRegBnds = 0.0d0

  AveOptPropAtmTemp = -1.0d0


  ! Read a namelist file

  call fi_open( CtlFN0, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = planetconst_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist, planetconst_nml, is something wrong.'
  end if
  write( 6, nml = planetconst_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = band_mode_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist band_mode_nml is something wrong.'
  end if
  write( 6, nml = band_mode_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = flag_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist flag_nml is something wrong.'
  end if
  write( 6, nml = flag_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = band_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist band_nml is something wrong.'
  end if
  write( 6, nml = band_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = gauss_region_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist gauss_region_nml is something wrong.'
  end if
  write( 6, nml = gauss_region_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN2, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = sort_file_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist sort_file_nml is something wrong.'
  end if
  write( 6, nml = sort_file_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN3, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = rte_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist rte_nml is something wrong.'
  end if
  write( 6, nml = rte_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN4, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = atm_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist atm_nml is something wrong.'
  end if
  write( 6, nml = atm_nml )
  !
  close( FileUnit )

  ! check namelist value
  if ( AveOptPropAtmTemp <= 0.0d0 ) then
    write( 6, * ) 'ERROR : AveOptPropAtmTemp is negative : ', AveOptPropAtmTemp
    stop
  end if


  OutSpeFluxNcFN     = trim( OutDir ) // '/' // 'Spectral_Flux.nc'
  OutFluxNcFN        = trim( OutDir ) // '/' // 'Flux.nc'
  OutTendencyNcFN    = trim( OutDir ) // '/' // 'Tendency.nc'
  OutOptPropGasNcFN  = trim( OutDir ) // '/' // 'op_gas_reordered.nc'
  OutOptPropPtclNcFN = trim( OutDir ) // '/' // 'op_ptcl_averaged.nc'


  EmisSW = 1.0d0 - AlbedoSW
  EmisLW = 1.0d0 - AlbedoLW

!!$  EmisSW = 1.0d0
!!$  EmisLW = 1.0d0 - AlbedoLW


  allocate( a_GaussRegBnds(0:NGaussReg) )
  a_GaussRegBnds = GaussRegBnds(1:NGaussReg+1)
  ! check
  if ( NGaussReg <= 0 ) then
    write( 6, * ) "NGaussReg is not appropriate: ", NGaussReg
    stop
  end if
  if ( ( a_GaussRegBnds(0) /= 0.0d0 ) .or. ( a_GaussRegBnds(NGaussReg) /= 1.0d0 ) ) then
    write( 6, * ) "GaussRegBnds is not appropriate: ", a_GaussRegBnds
    stop
  end if

  WNIntegStartSave = WNIntegStart
  WNIntegEndSave   = WNIntegEnd


  if ( NBand+1 > MaxNmlArySize ) then
    stop 'Array size is too large.'
  end if
  do n = 1, NBand
    if ( WNBnds(n) > WNBnds(n+1) ) then
      stop 'Band bounds does not increase monotonicaly.'
    end if
  end do


  do n = 1, MaxNmlArySize
    if ( KeyMolNum(n) < 0 ) then
      exit
    end if
  end do
  NKeyMol = n - 1
  allocate( ab_BandKeyMolNum (1:NKeyMol,1:NBand) )
  do n = 1, NBand
    ab_BandKeyMolNum(1:NKeyMol,n) = KeyMolNum(1:NKeyMol)
  end do


  allocate( ab_BandWNBnds    (2,NBand) )
  allocate( a_BandNBin       (NBand)   )

  do iBand = 1, NBand
    ab_BandWNBnds(1,iBand) = WNBnds   (iBand  )
    ab_BandWNBnds(2,iBand) = WNBnds   (iBand+1)
  end do
  a_BandNBin     (1:NBand) = BandNBin

  allocate( cb_BandGaussRegNBin (NGaussReg,NBand) )
  do iBand = 1, NBand
    do iGaussReg = 1, NGaussReg
      cb_BandGaussRegNBin(iGaussReg,iBand) = a_BandNBin(iBand) / NGaussReg
      if ( iGaussReg <= mod( a_BandNBin(iBand), NGaussReg ) ) then
        cb_BandGaussRegNBin(iGaussReg,iBand) = cb_BandGaussRegNBin(iGaussReg,iBand) + 1
      end if
    end do
  end do


  call fi_open( CtlFN, "read", FileUnit )
  !
  rewind( FileUnit )
  !
  do
    BandNum          = 0
    GaussRegNBins(:) = 0
    KeyMolNum        = -1
    read( FileUnit, nml = band_exception_nml, iostat = iostat )
    if ( iostat == -1 ) exit
    write( 6, nml = band_exception_nml )
    !
    if ( ( BandNum < 1 ) .or. ( NBand < BandNum ) ) then
      write( 6, * ) 'Unexpected band number, ', BandNum
      stop
    end if
    if ( KeyMolNum(1) < 1 ) then
      write( 6, * ) 'Unexpected key molecular number, ', KeyMolNum
      stop
    end if
    iBand = BandNum
    !
    do iGaussReg = 1, NGaussReg
      if ( GaussRegNBins(iGaussReg) <= 0 ) then
        write( 6, * ) 'Unexpected number of bins: '
        write( 6, * ) '  BandNum       = ', BandNum
        write( 6, * ) '  GaussRegNBins = ', GaussRegNBins
        stop
      end if
      cb_BandGaussRegNBin(iGaussReg,iBand) = GaussRegNBins(iGaussReg)
    end do
    a_BandNBin(iBand) = 0
    do iGaussReg = 1, NGaussReg
      a_BandNBin(iBand) = a_BandNBin(iBand) + cb_BandGaussRegNBin(iGaussReg,iBand)
    end do
    !
    do n = 1, MaxNmlArySize
      if ( KeyMolNum(n) < 0 ) then
        exit
      end if
    end do
    NKeyMolExcept = n - 1
    if ( NKeyMolExcept > NKeyMol ) then
      write( 6, * ) 'Unexpected number of key molecules for band #', iBand
      stop
    end if
    ab_BandKeyMolNum(:,iBand) = -1
    ab_BandKeyMolNum(1:NKeyMolExcept,iBand) = KeyMolNum(1:NKeyMolExcept)

  end do
  !
  close( FileUnit )

  write( 6, * ) 'Band number, Bin number, Number of bins'
  do iBand = 1, NBand
    write( 6, * ) iBand, ab_BandWNBnds(1,iBand), ab_BandWNBnds(2,iBand), a_BandNBin(iBand)
    do iGaussReg = 1, NGaussReg
      write( 6, * ) '               ', iGaussReg, cb_BandGaussRegNBin(iGaussReg,iBand)
    end do
  end do




  ! check
  do iBand = 1, NBand
    if ( a_BandNBin(iBand) < 0 ) then
      write( 6, * ) 'BandNBin is negative at ', iBand
      stop
    end if
  end do
!!$  do iBand = 1+1, NBand
!!$    do iKeyMol = 1, NKeyMol
!!$      if ( ab_BandKeyMolNum(iKeyMol,iBand) /= ab_BandKeyMolNum(iKeyMol,1) ) then
!!$        write( 6, * ) 'Now, KeyMolNum has to be the same for all bands.'
!!$        write( 6, * ) ab_BandKeyMolNum
!!$        stop
!!$      end if
!!$    end do
!!$  end do





  ! Initialize planetary constants
  !
  call RadPlanetConstInit( &
    & GravSet           = GravSet,           &
    & CpSet             = CpSet,             &
    & MolWtNonRadActSet = MolWtNonRadActSet  &
    & )


  call IOProfileInqDimLen(      &
    & InProfNcFN, "Press", &
    & kmax &
    & )
  kmax = kmax - 1
  call IOProfileInqDimLen(      &
    & InProfNcFN, "MolNum", &
    & NMol &
    & )
  allocate( m_MolNum   (1:NMol) )
  allocate( r_Press    (0:kmax) )
  allocate( r_Temp     (0:kmax) )
  allocate( rm_VMR     (0:kmax,NMol) )
  call IOProfileRead(      &
    & InProfNcFN, "Press", "MolNum", "Temp", "Ts", "VMR", &
    & kmax+1, NMol, &
    & r_Press, m_MolNum, r_Temp, SurfTemp, rm_VMR    &
    & )


  allocate( r_MeanMolWt(0:kmax) )

!!$  r_MeanMolWt = MeanMolWt

  allocate( r_VMRNonRadAct(0:kmax) )
  r_VMRNonRadAct = 1.0d0
  do m = 1, NMol
    r_VMRNonRadAct = r_VMRNonRadAct - rm_VMR(:,m)
  end do
  r_MeanMolWt = 0.0d0
  r_MeanMolWt = r_MeanMolWt + r_VMRNonRadAct * MolWtNonRadAct
  do m = 1, NMol
    r_MeanMolWt = r_MeanMolWt + rm_VMR(:,m) * m_HITRANMolWt(m_MolNum(m))
  end do
  deallocate( r_VMRNonRadAct )
  write( 6, * ) 'Mean molecular weight'
  do k = 0, kmax
    write( 6, * ) k, r_MeanMolWt(k)
  end do



  ! temporarily set
!!$  NPtcl              = 2
!!$  allocate( a_PtclName(NPtcl) )
!!$  allocate( za_PtclEffRad(kmax,NPtcl) )
!!$  allocate( za_DelPtclNum(kmax,NPtcl) )
!!$  a_PtclName(1)      = "H2OLiq"
!!$  a_PtclName(2)      = "H2OSol"
!!$  za_PtclEffRad(:,1) = 10.0d-6
!!$  za_PtclEffRad(:,2) = 50.0d-6
!!$  za_DelPtclNum      = 0.0d0

  if ( len_trim( InOrgPtclOptPropNcFN ) == 0 ) then

    NPtcl              = 0
    allocate( a_PtclName(NPtcl) )
    allocate( za_PtclDens   (kmax,NPtcl) )
    allocate( za_PtclEffRad (kmax,NPtcl) )
    allocate( za_DelPtclMass(kmax,NPtcl) )
    a_PtclName     = ""
    za_PtclDens    = 1.0d3  ! dummy
    za_PtclEffRad  = 0.0d0
    za_DelPtclMass = 0.0d0
    allocate( z_Press   (1:kmax) )

  else

    call IOProfileInqDimLen(      &
      & InProfNcFN, "PtclNum", &
      & NPtcl &
      & )
    !
    allocate( z_Press   (1:kmax) )
    allocate( a_PtclNum (NPtcl) )
    allocate( a_PtclName(NPtcl) )
    allocate( a_PtclDens(NPtcl) )
    allocate( za_PtclDens   (kmax,NPtcl) )
    allocate( za_PtclEffRad (kmax,NPtcl) )
    allocate( za_PtclMMR    (kmax,NPtcl) )
    allocate( za_DelPtclMass(kmax,NPtcl) )
    !
    write( 6, * ) NPtcl
    if ( NPtcl > 0 ) then
      call IOProfileReadPtcl(      &
        & InProfNcFN, &
        & kmax, NPtcl, &
        & z_Press, a_PtclNum, a_PtclName, a_PtclDens, za_PtclEffRad, za_PtclMMR  &
      & )
      do m = 1, NPtcl
        za_PtclDens(:,m) = a_PtclDens(m)
      end do
      deallocate( a_PtclDens )
      do m = 1, NPtcl
        do k = 1, kmax
!        za_DelPtclNum(k,m) = za_PtclMMR(k,m) &
!          & * ( r_Press(k-1) - r_Press(k) ) / Grav &
!          & / ( 4.0d0 / 3.0d0 * PI * za_PtclEffRad(k,m)**3 * a_PtclDens(m) )
          za_DelPtclMass(k,m) = za_PtclMMR(k,m) &
            & * ( r_Press(k-1) - r_Press(k) ) / Grav
        end do
      end do
    end if

  end if



  allocate( z_DTempDt  (1:kmax) )
  allocate( r_RadUwFlux(0:kmax) )
  allocate( r_RadDwFlux(0:kmax) )

  allocate( z_DTempDtLW      (1:kmax) )
  allocate( r_RadUwFluxLW    (0:kmax) )
  allocate( r_RadDwFluxLW    (0:kmax) )
  allocate( z_DTempDtSW      (1:kmax) )
  allocate( r_RadUwFluxSW    (0:kmax) )
  allocate( r_RadDwFluxSW    (0:kmax) )

  do k = 1, kmax
    z_Press(k) = ( r_Press(k-1) + r_Press(k) ) / 2.0d0
  end do



  if ( NGQ > 0 ) then
    NGQLoop = NGQ + 1
    allocate( a_GQMu    ( NGQ+1 ) )
    allocate( a_GQWeight( NGQ+1 ) )
    call GauLeg( 0.0d0, 1.0d0, NGQ, a_GQMu(1:NGQ), a_GQWeight(1:NGQ) )
    ! divid weights by 2 in order to consider night side
    a_GQWeight = a_GQWeight / 2.0d0
    ! night side
    a_GQMu    (NGQ+1) = -1.0d0
    a_GQWeight(NGQ+1) =  0.5d0
  else
    NGQLoop = 1
    allocate( a_GQMu    ( 1 ) )
    allocate( a_GQWeight( 1 ) )
    n = 1
    a_GQMu    (n) = cos( SZADeg * PI / 180.0d0 )
    a_GQWeight(n) = 1.0d0
  end if
  !
  allocate( s_SZADeg              (1:NGQLoop) )
  if ( NGQ > 0 ) then
    write( 6, '(i3,a)' ) NGQ, '-point Gaussian quadrature for dayside + nightside:'
  end if
  s_SZADeg = acos( a_GQMu ) * 180.0d0/PI


  WNIntegStart = WNIntegStartSave
  WNIntegEnd   = WNIntegEndSave

  if ( FlagCalcLBL ) then

    InNcFN            = InOrgOptPropNcFN
    InPtclOptPropNcFN = InOrgPtclOptPropNcFN
    InStrSpeNcFN      = StrSpeNcFN
    Method            = 'LBL'
    OutNcFN1          = OutFluxNcFN
    OutNcFN2          = OutTendencyNcFN
    call CalcAndOutputFlux( &
      & Grav, Cp, &
      & Method, InNcFN, InPtclOptPropNcFN, InStrSpeNcFN, OutNcFN1, OutNcFN2, &
      & kmax, NMol, m_MolNum, NPtcl, a_PtclName, &
      & r_Press, z_Press, &
      & SurfTemp, r_Temp, rm_VMR, r_MeanMolWt, &
      & za_PtclDens, za_PtclEffRad, za_DelPtclMass, &
      & WaveNumAlbedoSwitch, AlbedoSW, AlbedoLW, EmisSW, EmisLW, &
      & NGQ, a_GQWeight, NGQLoop, s_SZADeg, &
      & StrFluxTOA, &
      & WNIntegStart, WNIntegEnd, &
      & r_RadUwFluxLW, r_RadDwFluxLW, z_DTempDtLW, &
      & r_RadUwFluxSW, r_RadDwFluxSW, z_DTempDtSW, &
      & r_RadUwFlux  , r_RadDwFlux  , z_DTempDt    &
      & )
    allocate( r_RadUwFluxAllLBL  (0:kmax) )
    allocate( r_RadDwFluxAllLBL  (0:kmax) )
    allocate( r_RadUwFluxLWAllLBL(0:kmax) )
    allocate( r_RadDwFluxLWAllLBL(0:kmax) )
    allocate( r_RadUwFluxSWAllLBL(0:kmax) )
    allocate( r_RadDwFluxSWAllLBL(0:kmax) )

    r_RadUwFluxAllLBL   = r_RadUwFlux
    r_RadDwFluxAllLBL   = r_RadDwFlux
    r_RadUwFluxLWAllLBL = r_RadUwFluxLW
    r_RadDwFluxLWAllLBL = r_RadDwFluxLW
    r_RadUwFluxSWAllLBL = r_RadUwFluxSW
    r_RadDwFluxSWAllLBL = r_RadDwFluxSW

  end if

  allocate( r_RadUwFluxBandLBL  (0:kmax) )
  allocate( r_RadDwFluxBandLBL  (0:kmax) )
  allocate( r_RadUwFluxLWBandLBL(0:kmax) )
  allocate( r_RadDwFluxLWBandLBL(0:kmax) )
  allocate( r_RadUwFluxSWBandLBL(0:kmax) )
  allocate( r_RadDwFluxSWBandLBL(0:kmax) )


  PressForPFSort = r_Press(0)


  call fi_open( "QuickLook.data", "write", FileUnitQL )

  do iBand = max( iBands, 0 ), min( iBande, NBand+1 )
!!$  do iBand = 1, NBand+1
!!$  do iBand = NBand+1, NBand+1
!!$  do iBand = 0, 0
!!$  do iBand = 1, 1
!!$  do iBand = 4, 4
!!$  do iBand = 10, 10

    if ( ( iBand == 0 ) .or. ( iBand == NBand+1 ) ) then
      NBandCur = NBand
      allocate( ab_BandCurWNBnds      (2,NBandCur) )
      allocate( a_BandCurNBin         (NBandCur)   )
      allocate( cb_BandCurGaussRegNBin(NGaussReg,1:NBandCur) )

      ab_BandCurWNBnds      (:,1:NBandCur) = ab_BandWNBnds      (:,1:NBandCur)
      a_BandCurNBin           (1:NBandCur) = a_BandNBin           (1:NBandCur)
      cb_BandCurGaussRegNBin(:,1:NBandCur) = cb_BandGaussRegNBin(:,1:NBandCur)

      allocate( ab_BandCurKeyMolNum (1:NKeyMol,1:NBandCur) )
      ab_BandCurKeyMolNum(:,1:NBandCur) = ab_BandKeyMolNum(:,1:NBandCur)

      WNIntegStart = WNIntegStartSave
      WNIntegEnd   = WNIntegEndSave
    else
      NBandCur = 1
      allocate( ab_BandCurWNBnds (2,NBandCur) )
      allocate( a_BandCurNBin      (NBandCur) )
      allocate( cb_BandCurGaussRegNBin(NGaussReg,1:NBandCur) )

      ab_BandCurWNBnds      (:,1:NBandCur) = ab_BandWNBnds      (:,iBand:iBand)
      a_BandCurNBin           (1:NBandCur) = a_BandNBin           (iBand:iBand)
      cb_BandCurGaussRegNBin(:,1:NBandCur) = cb_BandGaussRegNBin(:,iBand:iBand)

      allocate( ab_BandCurKeyMolNum (1:NKeyMol,1:NBandCur) )
      ab_BandCurKeyMolNum(:,1:NBandCur) = ab_BandKeyMolNum(:,iBand:iBand)

      WNIntegStart = ab_BandCurWNBnds(1,1       )
      WNIntegEnd   = ab_BandCurWNBnds(2,NBandCur)
    end if


    if ( FlagCalcLBL ) then

      InNcFN            = InOrgOptPropNcFN
      InPtclOptPropNcFN = InOrgPtclOptPropNcFN
      InStrSpeNcFN      = StrSpeNcFN
      Method            = 'LBL'
      write( OutNcFN1, '(a,a,i2.2,a,a,a)' ) &
        & OutFluxNcFN(1:len_trim(OutFluxNcFN)-3), '-', iband, '-', 'LBL', '.nc'
      write( OutNcFN2, '(a,a,i2.2,a,a,a)' ) &
        & OutTendencyNcFN(1:len_trim(OutTendencyNcFN)-3), '-', iband, '-', 'LBL', '.nc'
      call CalcAndOutputFlux( &
        & Grav, Cp, &
        & Method, InNcFN, InPtclOptPropNcFN, InStrSpeNcFN, OutNcFN1, OutNcFN2, &
        & kmax, NMol, m_MolNum, NPtcl, a_PtclName, &
        & r_Press, z_Press, &
        & SurfTemp, r_Temp, rm_VMR, r_MeanMolWt, &
        & za_PtclDens, za_PtclEffRad, za_DelPtclMass, &
        & WaveNumAlbedoSwitch, AlbedoSW, AlbedoLW, EmisSW, EmisLW, &
        & NGQ, a_GQWeight, NGQLoop, s_SZADeg, &
        & StrFluxTOA, &
        & WNIntegStart, WNIntegEnd, &
        & r_RadUwFluxLW, r_RadDwFluxLW, z_DTempDtLW, &
        & r_RadUwFluxSW, r_RadDwFluxSW, z_DTempDtSW, &
        & r_RadUwFlux  , r_RadDwFlux  , z_DTempDt    &
        & )


      r_RadUwFluxBandLBL   = r_RadUwFlux
      r_RadDwFluxBandLBL   = r_RadDwFlux
      r_RadUwFluxLWBandLBL = r_RadUwFluxLW
      r_RadDwFluxLWBandLBL = r_RadDwFluxLW
      r_RadUwFluxSWBandLBL = r_RadUwFluxSW
      r_RadDwFluxSWBandLBL = r_RadDwFluxSW

    else

      r_RadUwFluxBandLBL   = 1.0d100
      r_RadDwFluxBandLBL   = 1.0d100
      r_RadUwFluxLWBandLBL = 1.0d100
      r_RadDwFluxLWBandLBL = 1.0d100
      r_RadUwFluxSWBandLBL = 1.0d100
      r_RadDwFluxSWBandLBL = 1.0d100

    end if



    do iMode = iModes, iModee
      write( 6, * ) 'iBand = ', iBand
      write( 6, * ) 'iMode = ', iMode
      call flush( 6 )


      select case ( iMode )
      case ( 0 )
        FlagSort                 = .false.
        Method                   = 'LBL'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .false.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
      case ( 1 )
        FlagSort                 = .false.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .false.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
      case ( 2 )
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .false.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        write( 6, * ) 'NOTICE : iMode = ', iMode, ', AC is sorted, but is not bin-averaged, and PtclOptProp is not sorted.'
      case ( 3 )
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        write( 6, * ) 'NOTICE : iMode = ', iMode, ', AC is sorted, but is not bin-averaged, and PtclOptProp is not sorted.'
      case ( 4 ) ! test for constant Planck function in each band
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .false.
        FlagPFRatioOne           = .true.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        write( 6, * ) 'NOTICE : iMode = ', iMode, ', AC is sorted, but is not bin-averaged, and PtclOptProp is not sorted.'
      case ( 5 ) ! test for correlation
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        write( 6, * ) 'NOTICE : iMode = ', iMode, ', AC is sorted, but is not bin-averaged, and PtclOptProp is not sorted.'
      case ( 6 )
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .true.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        write( 6, * ) 'NOTICE : iMode = ', iMode, ', AC is sorted, but is not bin-averaged, and PtclOptProp is not sorted.'
      case ( 7 ) ! the "best" with correlation before binning (2016/12/14)
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        write( 6, * ) 'NOTICE : iMode = ', iMode, ', AC is sorted, but is not bin-averaged, and PtclOptProp is not sorted.'
      case ( 8 ) ! the "best" with correlation and bin-averaged PF before binning (2017/04/18)
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .true.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        write( 6, * ) 'NOTICE : iMode = ', iMode, ', AC is sorted, but is not bin-averaged, and PtclOptProp is not sorted.'
      case ( 9 ) ! for demonstration
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .true.
        FlagBinning              = .true.
        FlagBinningDemonstration = .true.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
      case ( 10 ) ! the "best" with correlation and binning (2016/12/16)
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .true.
        FlagBinning              = .true.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
      case ( 11 ) ! for demonstration for non-correlation
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .true.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
      case ( 12 )
        FlagSort               = .true.
        Method                 = 'KDDevelop'
        FlagCorrelation        = .true.
        FlagKeyMolAbsOverlap   = .true.
        FlagPFRatioOne         = .false.
        FlagSortPFRatioAverage = .false.
        FlagBinning            = .true.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
      case default
        stop 'Unexpected value of iMode'
      end select

      write( 6, * ) "KeyMolNum                : "
      do n = 1, NBandCur
        write( 6, * ) "  Band: ", n, " : ", &
          & ( ab_BandCurKeyMolNum(iKeyMol,n), iKeyMol = 1, NKeyMol )
      end do
      write( 6, * ) "FlagSort                 : ", FlagSort
      write( 6, * ) "Method                   : ", trim( Method )
      write( 6, * ) "FlagCorrelation          : ", FlagCorrelation
      write( 6, * ) "FlagKeyMolAbsOverlap     : ", FlagKeyMolAbsOverlap
      write( 6, * ) "FlagPFRatioOne           : ", FlagPFRatioOne
      write( 6, * ) "FlagSortPFRatioAverage   : ", FlagSortPFRatioAverage
      write( 6, * ) "FlagBinning              : ", FlagBinning
      write( 6, * ) "FlagBinningDemonstration : ", FlagBinningDemonstration
      write( 6, * ) "FlagKeyMolACAverage      : ", FlagKeyMolACAverage
      write( 6, * ) "FlagNonKeyMolACAverage   : ", FlagNonKeyMolACAverage

      InNcFN       = InOrgOptPropNcFN
      InStrSpeNcFN = InOrgStrSpeNcFN
      write( OutGasNcFN, '(a,a,i2.2,a,i2.2,a)' ) &
        & OutOptPropGasNcFN(1:len_trim(OutOptPropGasNcFN)-3), '-', iband, '-', iMode, '.nc'
      call sortac( &
        & FlagSort, &
!        & InNcFN, OutNcFN, &
        & InNcFN, InProfNcFN, OutGasNcFN, &
        & FlagChkConstVMR, FlagBinning, FlagBinningDemonstration, &
        & FlagKeyMolACAverage, FlagNonKeyMolACAverage, &
        & FlagPFRatioOne, &
        & FlagSortPFRatioAverage, &
!        & NBand, a_BandWNBnds, a_BandKeyMolNum, a_BandNBin &
        & FlagCorrelation, &
        & FlagKeyMolAbsOverlap, &
        & InStrSpeNcFN, &
        & NBandCur, ab_BandCurWNBnds, a_BandCurNBin, &
        & NKeyMol, ab_BandCurKeyMolNum, &
        & NGaussReg, a_GaussRegBnds, cb_BandCurGaussRegNBin, &
        & PressForPFSort &
        & )

      select case ( trim( Method ) )
      case ( 'KDDevelop' )
        if ( len_trim( InOrgPtclOptPropNcFN ) > 0 ) then
          write( OutPtclNcFN, '(a,a,i2.2,a,i2.2,a)' ) &
            & OutOptPropPtclNcFN(1:len_trim(OutOptPropPtclNcFN)-3), '-', iband, '-', iMode, '.nc'
          call AveOptPropParticle( &
            & InStrSpeNcFN, InOrgPtclOptPropNcFN, OutPtclNcfn, &
            & AveOptPropAtmTemp, &
!!$            & NBandCur, ab_BandWNBnds &
            & NBandCur, ab_BandCurWNBnds &
            & )
          InPtclOptPropNcFN = OutPtclNcFN
        else
          InPtclOptPropNcFN = ""
        end if
      case default
        InPtclOptPropNcFN = InOrgPtclOptPropNcFN
      end select


      InNcFN = OutGasNcFN
      select case ( iMode )
      case ( 0 )
!!$        InStrSpeNcFN = InOrgStrSpeNcFN
        InStrSpeNcFN = StrSpeNcFN
      case default
        InStrSpeNcFN = OutGasNcFN
      end select
      write( OutNcFN1, '(a,a,i2.2,a,i2.2,a)' ) &
        & OutFluxNcFN(1:len_trim(OutFluxNcFN)-3), '-', iband, '-', iMode, '.nc'
      write( OutNcFN2, '(a,a,i2.2,a,i2.2,a)' ) &
        & OutTendencyNcFN(1:len_trim(OutTendencyNcFN)-3), '-', iband, '-', iMode, '.nc'
      call CalcAndOutputFlux( &
        & Grav, Cp, &
        & Method, InNcFN, InPtclOptPropNcFN, InStrSpeNcFN, OutNcFN1, OutNcFN2, &
        & kmax, NMol, m_MolNum, NPtcl, a_PtclName, &
        & r_Press, z_Press, &
        & SurfTemp, r_Temp, rm_VMR, r_MeanMolWt, &
        & za_PtclDens, za_PtclEffRad, za_DelPtclMass, &
        & WaveNumAlbedoSwitch, AlbedoSW, AlbedoLW, EmisSW, EmisLW, &
        & NGQ, a_GQWeight, NGQLoop, s_SZADeg, &
        & StrFluxTOA, &
        & WNIntegStart, WNIntegEnd, &
        & r_RadUwFluxLW, r_RadDwFluxLW, z_DTempDtLW, &
        & r_RadUwFluxSW, r_RadDwFluxSW, z_DTempDtSW, &
        & r_RadUwFlux  , r_RadDwFlux  , z_DTempDt    &
        & )

      if ( FlagCalcLBL ) then

        write( 6, * ) '--- Each Band ---'
        call EstimateError(&
          & FileUnitQL, &
          & NBandCur, ab_BandCurWNBnds, &
          & iBand, iMode, &
          & kmax, &
          & r_RadUwFlux     , r_RadDwFlux     , &
          & r_RadUwFluxLW   , r_RadDwFluxLW   , &
          & r_RadUwFluxSW   , r_RadDwFluxSW   , &
          & r_RadUwFluxBandLBL  , r_RadDwFluxBandLBL  , &
          & r_RadUwFluxLWBandLBL, r_RadDwFluxLWBandLBL, &
          & r_RadUwFluxSWBandLBL, r_RadDwFluxSWBandLBL  &
          & )
        write( 6, * ) '--- All Bands ---'
        call EstimateError(&
          & FileUnitQL, &
          & NBandCur, ab_BandCurWNBnds, &
          & iBand, iMode, &
          & kmax, &
          & r_RadUwFlux     , r_RadDwFlux     , &
          & r_RadUwFluxLW   , r_RadDwFluxLW   , &
          & r_RadUwFluxSW   , r_RadDwFluxSW   , &
          & r_RadUwFluxBandLBL  , r_RadDwFluxBandLBL  , &
          & r_RadUwFluxLWBandLBL, r_RadDwFluxLWBandLBL, &
          & r_RadUwFluxSWBandLBL, r_RadDwFluxSWBandLBL, &
          & r_RadUwFluxAllLBL   , r_RadDwFluxAllLBL   , &
          & r_RadUwFluxLWAllLBL , r_RadDwFluxLWAllLBL , &
          & r_RadUwFluxSWAllLBL , r_RadDwFluxSWAllLBL   &
          & )

      end if

    end do


    deallocate( ab_BandCurWNBnds       )
    deallocate( a_BandCurNBin          )
    deallocate( cb_BandCurGaussRegNBin )
    deallocate( ab_BandCurKeyMolNum    )

  end do

  close( FileUnitQL )

  deallocate( z_DTempDt   )
  deallocate( r_RadUwFlux )
  deallocate( r_RadDwFlux )

  deallocate( r_RadUwFluxLW     )
  deallocate( r_RadDwFluxLW     )
  deallocate( r_RadUwFluxSW     )
  deallocate( r_RadDwFluxSW     )

  deallocate( a_GaussRegBnds )

  deallocate( a_PtclName     )
  deallocate( za_PtclDens    )
  deallocate( za_PtclEffRad  )
  deallocate( za_DelPtclMass )

  deallocate( m_MolNum    )
  deallocate( r_Press     )
  deallocate( z_Press     )
  deallocate( r_Temp      )
  deallocate( rm_VMR      )
  deallocate( r_MeanMolWt )


  deallocate( ab_BandWNBnds     )
  deallocate( a_BandNBin        )
  deallocate( ab_BandKeyMolNum  )

  deallocate( cb_BandGaussRegNBin  )

  deallocate( r_RadUwFluxBandLBL )
  deallocate( r_RadDwFluxBandLBL )


  write( 6, * ) "Finish"


end program main

