program main

  use vtype_module
  use fi_module
  use ni3_module

  use sortac_module, only : sortac

#ifdef MPI
  use mpi
#endif


  implicit none


  character(extstr) :: CtlFN  = 'sort_ac.conf'
  character(extstr) :: CtlFN2 = 'file.conf'
  character(extstr) :: CtlFN3 = 'many.conf'

  integer :: FileUnit
  integer :: iostat

  integer           :: InNcID
  character(stdstr) :: Mode


  logical :: FlagChkConstVMR
  logical :: FlagKeyMolACAverage
  logical :: FlagNonKeyMolACAverage
  logical :: FlagPFRatioOne
  logical :: FlagSortPFRatioAverage

  integer, parameter :: MaxNmlArySize = 256
  real(8)            :: WNBnds(MaxNmlArySize)
  integer            :: KeyMolNum(MaxNmlArySize)

  integer              :: BandNBin
  integer              :: NKeyMol
  integer              :: NKeyMolExcept

  integer              :: NBand
  real(8), allocatable :: ab_BandWNBnds    (:,:)
  integer, allocatable :: a_BandNBin       (:)
  integer, allocatable :: ab_BandKeyMolNum (:,:)

  integer, allocatable :: cb_BandGaussRegNBin (:,:)
  integer              :: iGaussReg

  integer              :: NBandCur = 1
  real(8), allocatable :: ab_BandCurWNBnds    (:,:)
  integer, allocatable :: a_BandCurNBin       (:)
  integer, allocatable :: cb_BandCurGaussRegNBin(:,:)
  integer, allocatable :: ab_BandCurKeyMolNum (:,:)

  integer :: n


  ! 設定変数, 他
  ! setteing parameter, values
  !
  character(128) :: InDir
  character(128) :: OutDir
  character(128) :: InOrgOptPropNcFN
                          ! 
                          ! input file name for original optical properties
!!$  logical        :: FlagOutSpeFlux
!!$  character(128) :: OutSpeFluxNcFN
  character(128) :: OutOptPropNcFN
!!$  character(128) :: OutFluxNcFN
!!$  character(128) :: OutTendencyNcFN

  character(128) :: StrSpeNcFN

!!$  real(8) :: CentStarConst
!!$  real(8) :: InAngle
                          ! sec (太陽光入射角) [1]
                          ! sec (angle of incidence) [1]
!!$  real(8) :: SurfAlbedo
                          ! 地表面アルベド [1]
                          ! surface albedo [1]


  character(128) :: InNcFN
  character(128) :: OutNcFN

  real(8) :: PressForPFSort

!!$  integer :: kmax

  logical :: FlagSort
  logical :: FlagBinning
  logical :: FlagBinningDemonstration
  logical :: FlagCorrelation
  logical :: FlagKeyMolAbsOverlap

  integer              :: NGaussReg
  real(8), allocatable :: a_GaussRegBnds(:)
  real(8)              :: GaussRegBnds(MaxNmlArySize)

  integer              :: BandNum
  integer              :: GaussRegNBins(MaxNmlArySize)

  character(128) :: Method

!!$  integer :: iLoop
  integer :: iMode
  integer :: iBand

  integer :: iBands
  integer :: iBande
  integer :: iModes
  integer :: iModee

!!$  integer :: k
!!$  integer :: m
  integer :: iKeyMol


  character(len=extstr)     :: FileNameTail

  integer :: iTemp
  integer :: iTemps
  integer :: iTempe
  integer :: Mol1Num
  integer :: iVMRMol1
  integer :: iVMRMol1s
  integer :: iVMRMol1e
  integer :: Mol2Num
  integer :: iVMRMol2
  integer :: iVMRMol2s
  integer :: iVMRMol2e
  integer :: Mol3Num
  integer :: iVMRMol3
  integer :: iVMRMol3s
  integer :: iVMRMol3e

  integer :: NTemp
  integer :: NVMRMol1
  integer :: NVMRMol2
  integer :: NVMRMol3


  ! Below are variables for copying absorption coefficient.
  !
  ! In order to save computational time, absorption coefficient spectra at
  ! reference composition for species whose amount is much less than 1
  ! will be copied to those at other volume mixing ratios. 
  !
  ! FlagCopyVarMolAbsCoef : Flag for copying absorption coefficient of
  !                       : reference composition for other values of
  !                       : composition (volume mixing ration)
  logical              :: FlagCopyVarMolAbsCoef
  ! VarMolRangeNcFN       : Name of netcdf file for variable molecules' range
  character(extstr)    :: VarMolRangeNcFN
  ! VarMol1Num            : Molecular number of variable molecule 1
  integer              :: VarMol1Num
  integer              :: VarMol2Num
  integer              :: VarMol3Num
  integer              :: m_VarMolNum(3)
  ! iVMRVarMolXRef        : Index for variable molecule X whose absorption
  !                       : coefficient is copied
  integer              :: iVMRVarMol1Ref
  integer              :: iVMRVarMol2Ref
  integer              :: iVMRVarMol3Ref
  ! NVMRVarMolXAll        : Number of all volume mixing ratios for variable
  !                       : molecule X (Full range, which may include out of
  !                       : range of loop)
  integer              :: NVMRVarMol1All
  integer              :: NVMRVarMol2All
  integer              :: NVMRVarMol3All
  ! x_VMRVarMolXAll       : All volume mixing ratios for variable molecule X
  !                       : (Full range, which may include out of range of
  !                       : loop)
  real(8), allocatable :: u_VMRVarMol1All(:)
  real(8), allocatable :: v_VMRVarMol2All(:)
  real(8), allocatable :: w_VMRVarMol3All(:)
  real(8)              :: m_VMRVarMol(3)


  integer :: iLoop
  integer :: NLoop
  integer :: iLoops
  integer :: iLoope

  integer :: iRank

  integer :: IErr
  integer :: NProcs
  integer :: MyRank

  integer :: m
  integer :: i1
  integer :: i2
  integer :: i3


  namelist /band_mode_nml/ &
    & iBands, iBande, iModes, iModee
  namelist /flag_nml/ &
!!$    & FlagChkConstH2OMR, FlagKeyMolACAverage, FlagNonKeyMolACAverage
    & FlagChkConstVMR
  namelist /file_nml/ &
    & InDir, OutDir
!!$    & InProfNcFn, &
!!$!    & InNcFN, OutNcFN
!!$    & InOrgOptPropNcFN, &
!!$    & FlagOutSpeFlux,  &
!!$    & OutSpeFluxNcFN,  &
!!$    & OutFluxNcFN,     &
!!$    & OutTendencyNcFN, &
!!$    & OutOptPropNcFN
  namelist /band_nml/ &
    & NBand, WNBnds, BandNBin, KeyMolNum
  namelist /band_exception_nml/ &
    & BandNum, GaussRegNBins, KeyMolNum
  namelist /star_nml/ &
    & StrSpeNcFN

  namelist /gauss_region_nml/ &
    & NGaussReg, GaussRegBnds


  namelist /many_nml/ &
    & iTemps, iTempe, &
    & Mol1Num, iVMRMol1s, iVMRMol1e, &
    & Mol2Num, iVMRMol2s, iVMRMol2e, &
    & Mol3Num, iVMRMol3s, iVMRMol3e

!!$  namelist /press_nml/ &
!!$    & PressForPFSort

  namelist /copy_abscoef_nml/                     &
    & FlagCopyVarMolAbsCoef, VarMolRangeNcFN,     &
    & VarMol1Num, VarMol2Num, VarMol3Num,         &
    & iVMRVarMol1Ref, iVMRVarMol2Ref, iVMRVarMol3Ref


#ifdef MPI
  call mpi_init( IErr )
  call mpi_comm_size( mpi_comm_world, NProcs, IErr )
  call mpi_comm_rank( mpi_comm_world, MyRank, IErr )
#else
  NProcs = 1
  MyRank = 0
#endif




  FlagChkConstVMR      = .true.

  StrSpeNcFN = ""

  NBand = 1
  WNBnds    = -999.0d0
  WNBnds(1) = 0.0d0
  WNBnds(2) = 1.0d100
  KeyMolNum    = -1
  KeyMolNum(1) = 1
  BandNBin     = 10

  GaussRegBnds = 0.0d0


!!$  PressForPFSort = -1.0d0
  PressForPFSort = 1.0d5

  InDir  = "../prog05.0_calc_ac_many_mpi/out"
  OutDir = "out"

  FlagCopyVarMolAbsCoef = .false.
  VarMolRangeNcFN       = ""
  VarMol1Num            = -1
  VarMol2Num            = -1
  VarMol3Num            = -1
  iVMRVarMol1Ref        = -1
  iVMRVarMol2Ref        = -1
  iVMRVarMol3Ref        = -1

  ! Read a namelist file

  call fi_open( CtlFN, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = band_mode_nml, iostat = iostat )
  write( 6, * ) iostat
  if ( iostat /= 0 ) then
    stop 'Namelist, band_mode_nml, is something wrong.'
  end if
  write( 6, nml = band_mode_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = flag_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist, flag_nml, is something wrong.'
  end if
  write( 6, nml = flag_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = band_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist, band_nml, is something wrong.'
  end if
  write( 6, nml = band_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = star_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist, star_nml, is something wrong.'
  end if
  write( 6, nml = star_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = gauss_region_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist, gauss_region_nml, is something wrong.'
  end if
  write( 6, nml = gauss_region_nml )
  !
  ! PressForPFSort is not used, now.
!!$  rewind( FileUnit )
!!$  read( FileUnit, nml = press_nml, iostat = iostat )
!!$  if ( iostat /= 0 ) then
!!$    stop 'Namelist, press_nml, is something wrong.'
!!$  end if
!!$  write( 6, nml = press_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN2, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = file_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist in file_nml is something wrong.'
  end if
  rewind( FileUnit )
  read( FileUnit, nml = copy_abscoef_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist in copy_abscoef_nml is something wrong.'
  end if
  write( 6, nml = file_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN3, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = many_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist in file_nml is something wrong.'
  end if
  write( 6, nml = many_nml )
  !
  close( FileUnit )


  if ( PressForPFSort < 0.0d0 ) then
    write( 6, * ) 'PressForPFSort is negative: ', PressForPFSort
    stop
  end if


  allocate( a_GaussRegBnds(0:NGaussReg) )
  a_GaussRegBnds = GaussRegBnds(1:NGaussReg+1)
  ! check
  if ( NGaussReg <= 0 ) then
    write( 6, * ) "NGaussReg is not appropriate: ", NGaussReg
    stop
  end if
  if ( ( a_GaussRegBnds(0) /= 0.0d0 ) .or. ( a_GaussRegBnds(NGaussReg) /= 1.0d0 ) ) then
    write( 6, * ) "GaussRegBnds is not appropriate: ", a_GaussRegBnds
    stop
  end if




  do n = 1, MaxNmlArySize
    if ( KeyMolNum(n) < 0 ) then
      exit
    end if
  end do
  NKeyMol = n - 1
  allocate( ab_BandKeyMolNum (1:NKeyMol,1:NBand) )
  do n = 1, NBand
    ab_BandKeyMolNum(1:NKeyMol,n) = KeyMolNum(1:NKeyMol)
  end do


  if ( NBand+1 > MaxNmlArySize ) then
    stop 'Array size is too large.'
  end if
  do n = 1, NBand
    if ( WNBnds(n) > WNBnds(n+1) ) then
      write( 6, * ) 'ERROR: Band bounds does not increase monotonicaly.'
      write( 6, * ) n, WNBnds(n), WNBnds(n+1)
      stop
    end if
  end do


  allocate( ab_BandWNBnds    (2,NBand) )
  allocate( a_BandNBin         (NBand) )

  do iBand = 1, NBand
    ab_BandWNBnds(1,iBand) = WNBnds(iBand  )
    ab_BandWNBnds(2,iBand) = WNBnds(iBand+1)
  end do
  a_BandNBin     (1:NBand) = BandNBin


  allocate( cb_BandGaussRegNBin (NGaussReg,NBand) )
  do iBand = 1, NBand
    do iGaussReg = 1, NGaussReg
      cb_BandGaussRegNBin(iGaussReg,iBand) = a_BandNBin(iBand) / NGaussReg
      if ( iGaussReg <= mod( a_BandNBin(iBand), NGaussReg ) ) then
        cb_BandGaussRegNBin(iGaussReg,iBand) = cb_BandGaussRegNBin(iGaussReg,iBand) + 1
      end if
    end do
  end do


  call fi_open( CtlFN, "read", FileUnit )
  !
  rewind( FileUnit )
  !
  do
    BandNum          = 0
    GaussRegNBins(:) = 0
    KeyMolNum        = -1
    read( FileUnit, nml = band_exception_nml, iostat = iostat )
    if ( iostat == -1 ) exit
    write( 6, nml = band_exception_nml )
    !
    if ( ( BandNum < 1 ) .or. ( NBand < BandNum ) ) then
      write( 6, * ) 'Unexpected band number, ', BandNum
      stop
    end if
    if ( KeyMolNum(1) < 1 ) then
      write( 6, * ) 'Unexpected key molecular number, ', KeyMolNum
      stop
    end if
    iBand = BandNum
    !
    do iGaussReg = 1, NGaussReg
      if ( GaussRegNBins(iGaussReg) <= 0 ) then
        write( 6, * ) 'Unexpected number of bins: '
        write( 6, * ) '  BandNum       = ', BandNum
        write( 6, * ) '  GaussRegNBins = ', GaussRegNBins
        stop
      end if
      cb_BandGaussRegNBin(iGaussReg,iBand) = GaussRegNBins(iGaussReg)
    end do
    a_BandNBin(iBand) = 0
    do iGaussReg = 1, NGaussReg
      a_BandNBin(iBand) = a_BandNBin(iBand) + cb_BandGaussRegNBin(iGaussReg,iBand)
    end do
    !
    do n = 1, MaxNmlArySize
      if ( KeyMolNum(n) < 0 ) then
        exit
      end if
    end do
    NKeyMolExcept = n - 1
    if ( NKeyMolExcept > NKeyMol ) then
      write( 6, * ) 'Unexpected number of key molecules for band #', iBand
      stop
    end if
    ab_BandKeyMolNum(:,iBand) = -1
    ab_BandKeyMolNum(1:NKeyMolExcept,iBand) = KeyMolNum(1:NKeyMolExcept)
  end do
  !
  close( FileUnit )

  write( 6, * ) 'Band number, Bin number, Number of bins'
  do iBand = 1, NBand
    write( 6, * ) iBand, ab_BandWNBnds(1,iBand), ab_BandWNBnds(2,iBand), a_BandNBin(iBand)
    do iGaussReg = 1, NGaussReg
      write( 6, * ) '               ', iGaussReg, cb_BandGaussRegNBin(iGaussReg,iBand)
    end do
  end do


  ! Variable molecules' range
  m_VarMolNum(1) = VarMol1Num
  m_VarMolNum(2) = VarMol2Num
  m_VarMolNum(3) = VarMol3Num
  if ( FlagCopyVarMolAbsCoef ) then
    do m = 1, 3
      if ( m_VarMolNum(m) < 0 ) then
        write( 6, '(a,i1,a,i2.2,a)' ) &
          & 'ERROR: Unexpected molecular number for variable molecule ', m, &
          & ' : ', m_VarMolNum(m), '.'
        stop
      end if
    end do
    Mode = "read"
    call ni3_open( VarMolRangeNcFN, Mode, InNcID )
    call ni3_inq_dimlen( InNcID, "VMR1", NVMRVarMol1All )
    call ni3_inq_dimlen( InNcID, "VMR2", NVMRVarMol2All )
    call ni3_inq_dimlen( InNcID, "VMR3", NVMRVarMol3All )
    allocate( u_VMRVarMol1All( NVMRVarMol1All ) )
    allocate( v_VMRVarMol2All( NVMRVarMol2All ) )
    allocate( w_VMRVarMol3All( NVMRVarMol3All ) )
    call ni3_get_var( InNcID, "VMR1", u_VMRVarMol1All )
    call ni3_get_var( InNcID, "VMR2", v_VMRVarMol2All )
    call ni3_get_var( InNcID, "VMR3", w_VMRVarMol3All )
    call ni3_close( InNcID )
  else
    NVMRVarMol1All = 0
    NVMRVarMol2All = 0
    NVMRVarMol3All = 0
    allocate( u_VMRVarMol1All( NVMRVarMol1All ) )
    allocate( v_VMRVarMol2All( NVMRVarMol2All ) )
    allocate( w_VMRVarMol3All( NVMRVarMol3All ) )
  end if



  ! check
!!$  do iBand = 1+1, NBand
!!$    do iKeyMol = 1, NKeyMol
!!$      if ( ab_BandKeyMolNum(iKeyMol,iBand) /= ab_BandKeyMolNum(iKeyMol,1) ) then
!!$        write( 6, * ) 'Now, KeyMolNum has to be the same for all bands.'
!!$        write( 6, * ) ab_BandKeyMolNum
!!$        stop
!!$      end if
!!$    end do
!!$  end do



  NTemp    = iTempe    - iTemps    + 1
  NVMRMol1 = iVMRMol1e - iVMRMol1s + 1
  NVMRMol2 = iVMRMol2e - iVMRMol2s + 1
  NVMRMol3 = iVMRMol3e - iVMRMol3s + 1

  NLoop = NTemp * NVMRMol1 * NVMRMol2 * NVMRMol3

  iLoope = 0
  do iRank = 0, MyRank
    iLoops = iLoope + 1
    iLoope = iLoops + NLoop / NProcs - 1
    if ( iRank < mod( NLoop, NProcs ) ) then
      iLoope = iLoope + 1
    end if
  end do
  ! check
  if ( iLoope > NLoop ) then
    write( 6, * ) 'Unexpected number of maximum of loop: ', iLoope, NLoop
  end if


  do iLoop = iLoops, iLoope

    iTemp       = iTemps       &
      & + ( iLoop - 1 ) / ( NVMRMol1 * NVMRMol2 * NVMRMol3 )
    iVMRMol1 = iVMRMol1s &
      & + mod( ( iLoop - 1 ) / ( NVMRMol2 * NVMRMol3 ), NVMRMol1 )
    iVMRMol2 = iVMRMol2s &
      & + mod( ( iLoop - 1 ) / ( NVMRMol3 ), NVMRMol2 )
    iVMRMol3 = iVMRMol3s &
      & + mod( ( iLoop - 1 ), NVMRMol3 )


    if ( FlagCopyVarMolAbsCoef ) then
      i1 = iVMRVarMol1Ref
      i2 = iVMRVarMol2Ref
      i3 = iVMRVarMol3Ref
      m_VMRVarMol(1) = u_VMRVarMol1All(iVMRMol1)
      m_VMRVarMol(2) = v_VMRVarMol2All(iVMRMol2)
      m_VMRVarMol(3) = w_VMRVarMol3All(iVMRMol3)
    else
      i1 = iVMRMol1
      i2 = iVMRMol2
      i3 = iVMRMol3
      m_VMRVarMol(:) = -1.0d100
    end if
    write( FileNameTail, '(a,i3.3,3(a,i2.2,a,i3.3),a)' ) &
      & "T-", iTemp, &
      & "_M", Mol1Num, "-", i1, &
      & "_M", Mol2Num, "-", i2, &
      & "_M", Mol3Num, "-", i3, &
      & ".nc"
    InOrgOptPropNcFN = trim( InDir  ) // "/ac_" // trim( FileNameTail )
    write( 6, * ) 'Input : ', trim( InOrgOptPropNcFN )

    i1 = iVMRMol1
    i2 = iVMRMol2
    i3 = iVMRMol3
    write( FileNameTail, '(a,i3.3,3(a,i2.2,a,i3.3),a)' ) &
      & "T-", iTemp, &
      & "_M", Mol1Num, "-", i1, &
      & "_M", Mol2Num, "-", i2, &
      & "_M", Mol3Num, "-", i3, &
      & ".nc"
    OutOptPropNcFN   = trim( OutDir ) // "/ac_" // trim( FileNameTail )
    write( 6, * ) 'Output: ', trim( OutOptPropNcFN )



    InNcFN = InOrgOptPropNcFN



    do iBand = max( iBands, 0 ), min( iBande, NBand+1 )
!!$  do iBand = 1, NBand+1
!!$  do iBand = NBand+1, NBand+1
!!$  do iBand = 0, 0
!!$  do iBand = 1, 1
!!$  do iBand = 4, 4
!!$  do iBand = 10, 10

!!$    if ( iBand == 0 ) then
      if ( ( iBand == 0 ) .or. ( iBand == NBand+1 ) ) then
        NBandCur = NBand
        allocate( ab_BandCurWNBnds    (2,NBandCur) )
        allocate( a_BandCurNBin         (NBandCur) )
        allocate( cb_BandCurGaussRegNBin(NGaussReg,1:NBandCur) )

        ab_BandCurWNBnds(:,1:NBandCur) = ab_BandWNBnds(:,1:NBandCur)
        a_BandCurNBin     (1:NBandCur) = a_BandNBin     (1:NBandCur)
        cb_BandCurGaussRegNBin(:,1:NBandCur) = cb_BandGaussRegNBin(:,1:NBandCur)
        allocate( ab_BandCurKeyMolNum (1:NKeyMol,1:NBandCur) )
        ab_BandCurKeyMolNum(:,1:NBandCur) = ab_BandKeyMolNum(:,1:NBandCur)
      else
        NBandCur = 1
        allocate( ab_BandCurWNBnds (2,NBandCur) )
        allocate( a_BandCurNBin      (NBandCur) )
        allocate( cb_BandCurGaussRegNBin(NGaussReg,1:NBandCur) )

        ab_BandCurWNBnds  (:,1:NBandCur) = ab_BandWNBnds(:,iBand:iBand)
        a_BandCurNBin       (1:NBandCur) = a_BandNBin     (iBand:iBand)
        cb_BandCurGaussRegNBin(:,1:NBandCur) = cb_BandGaussRegNBin(:,iBand:iBand)

        allocate( ab_BandCurKeyMolNum (1:NKeyMol,1:NBandCur) )
        ab_BandCurKeyMolNum(:,1:NBandCur) = ab_BandKeyMolNum(:,iBand:iBand)
      end if



      do iMode = iModes, iModee
!!$    do iLoop = 0, 0
!!$    do iLoop = 0, 1
!!$    do iLoop = 0, 3
!!$    do iLoop = 0, 4
!!$    do iLoop = 0, 5
!!$    do iLoop = 0, 6
!!$    do iLoop = 0, 7
!!$    do iLoop = 0, 9
!!$    do iLoop = 1, 1
!!$    do iLoop = 2, 2
!!$    do iLoop = 3, 3
!!$    do iLoop = 4, 4
!!$    do iLoop = 5, 5
!!$    do iLoop = 6, 6
!!$    do iLoop = 7, 7
!!$    do iLoop = 7, 9
!!$    do iLoop = 8, 9
        write( 6, * ) 'iBand = ', iBand
        write( 6, * ) 'iMode = ', iMode


        select case ( iMode )
        case ( 0 )
          FlagSort                 = .false.
          Method                   = 'LBL'
          FlagCorrelation          = .false.
          FlagKeyMolAbsOverlap     = .false.
          FlagPFRatioOne           = .false.
          FlagSortPFRatioAverage   = .false.
          FlagBinning              = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 1 )
          FlagSort               = .false.
          Method                 = 'LBLConstPF'
          FlagCorrelation        = .false.
          FlagKeyMolAbsOverlap   = .false.
          FlagPFRatioOne         = .false.
          FlagSortPFRatioAverage = .false.
          FlagBinning            = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 2 )
          FlagSort               = .true.
          Method                 = 'LBLConstPF'
          FlagCorrelation        = .false.
          FlagKeyMolAbsOverlap   = .false.
          FlagPFRatioOne         = .false.
          FlagSortPFRatioAverage = .false.
          FlagBinning            = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 3 )
          FlagSort               = .true.
          Method                 = 'LBLConstPF'
          FlagCorrelation        = .false.
          FlagKeyMolAbsOverlap   = .true.
          FlagPFRatioOne         = .false.
          FlagSortPFRatioAverage = .false.
          FlagBinning            = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 4 )
          FlagSort               = .true.
          Method                 = 'LBLConstPF'
          FlagCorrelation        = .false.
          FlagKeyMolAbsOverlap   = .false.
          FlagPFRatioOne         = .true.
          FlagSortPFRatioAverage = .false.
          FlagBinning            = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 5 )
          FlagSort               = .true.
          Method                 = 'LBLConstPF'
          FlagCorrelation        = .true.
          FlagKeyMolAbsOverlap   = .true.
          FlagPFRatioOne         = .false.
          FlagSortPFRatioAverage = .false.
          FlagBinning            = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 6 )
          FlagSort               = .true.
          Method                 = 'LBLConstPF'
          FlagCorrelation        = .true.
          FlagKeyMolAbsOverlap   = .true.
          FlagPFRatioOne         = .true.
          FlagSortPFRatioAverage = .false.
          FlagBinning            = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 7 ) ! no effect (meaningless) now
          FlagSort                 = .true.
          Method                   = 'LBLConstPF'
          FlagCorrelation          = .false.
          FlagKeyMolAbsOverlap     = .true.
          FlagPFRatioOne           = .false.
          FlagSortPFRatioAverage   = .true.
          FlagBinning              = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 8 ) ! the "best" with correlation before binning (2016/12/14)
          FlagSort                 = .true.
          Method                   = 'KDDevelop'
          FlagCorrelation          = .true.
          FlagKeyMolAbsOverlap     = .true.
          FlagPFRatioOne           = .false.
          FlagSortPFRatioAverage   = .false.
          FlagBinning              = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 9 )
          FlagSort                 = .true.
          Method                   = 'KDDevelop'
          FlagCorrelation          = .true.
          FlagKeyMolAbsOverlap     = .true.
          FlagPFRatioOne           = .false.
          FlagSortPFRatioAverage   = .true.
          FlagBinning              = .true.
          FlagBinningDemonstration = .true.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 10 ) ! the "best" with correlation and binning (2016/12/16)
          FlagSort                 = .true.
          Method                   = 'KDDevelop'
          FlagCorrelation          = .true.
          FlagKeyMolAbsOverlap     = .true.
          FlagPFRatioOne           = .false.
          FlagSortPFRatioAverage   = .true.
          FlagBinning              = .true.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 11 )
          FlagSort               = .true.
          Method                 = 'KDDevelop'
          FlagCorrelation        = .true.
          FlagKeyMolAbsOverlap   = .true.
          FlagPFRatioOne         = .false.
          FlagSortPFRatioAverage = .false.
          FlagBinning            = .false.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case ( 12 )
          FlagSort               = .true.
          Method                 = 'KDDevelop'
          FlagCorrelation        = .true.
          FlagKeyMolAbsOverlap   = .true.
          FlagPFRatioOne         = .false.
          FlagSortPFRatioAverage = .false.
          FlagBinning            = .true.
          FlagBinningDemonstration = .false.
          FlagKeyMolACAverage      = .false.
          FlagNonKeyMolACAverage   = .true.
        case default
          stop 'Unexpected value of iMode'
        end select

        write( 6, * ) "KeyMolNum                : "
        do n = 1, NBandCur
          write( 6, * ) "  Band: ", n, " : ", &
            & ( ab_BandCurKeyMolNum(iKeyMol,n), iKeyMol = 1, NKeyMol )
        end do
        write( 6, * ) "FlagSort                 : ", FlagSort
        write( 6, * ) "Method                   : ", trim( Method )
        write( 6, * ) "FlagCorrelation          : ", FlagCorrelation
        write( 6, * ) "FlagKeyMolAbsOverlap     : ", FlagKeyMolAbsOverlap
        write( 6, * ) "FlagPFRatioOne           : ", FlagPFRatioOne
        write( 6, * ) "FlagSortPFRatioAverage   : ", FlagSortPFRatioAverage
        write( 6, * ) "FlagBinning              : ", FlagBinning
        write( 6, * ) "FlagBinningDemonstration : ", FlagBinningDemonstration
        write( 6, * ) "FlagKeyMolACAverage      : ", FlagKeyMolACAverage
        write( 6, * ) "FlagNonKeyMolACAverage   : ", FlagNonKeyMolACAverage

        InNcFN = InOrgOptPropNcFN
        write( OutNcFN, '(a,a,i2.2,a,i2.2,a)' ) &
          & OutOptPropNcFN(1:len_trim(OutOptPropNcFN)-3), '-', iband, '-', iMode, '.nc'
        call sortac( &
          & FlagSort, &
          & InNcFN, InNcFN, OutNcFN, &
          & FlagChkConstVMR, FlagBinning, FlagBinningDemonstration, &
          & FlagKeyMolACAverage, FlagNonKeyMolACAverage, &
          & FlagPFRatioOne, &
          & FlagSortPFRatioAverage, &
          !        & NBand, a_BandWNBnds, a_BandKeyMolNum, a_BandNBin &
          & FlagCorrelation, &
          & FlagKeyMolAbsOverlap, &
          & StrSpeNcFN, &
          & NBandCur, ab_BandCurWNBnds, a_BandCurNBin, &
          & NKeyMol, ab_BandCurKeyMolNum, &
          & NGaussReg, a_GaussRegBnds, cb_BandCurGaussRegNBin, &
          & PressForPFSort, &
          & FlagCopyVarMolAbsCoef, VarMolRangeNcFN, m_VarMolNum, m_VMRVarMol & ! optional
          & )

      end do


      deallocate( ab_BandCurWNBnds       )
      deallocate( a_BandCurNBin          )
      deallocate( cb_BandCurGaussRegNBin )
      deallocate( ab_BandCurKeyMolNum    )

    end do

  end do


  deallocate( ab_BandWNBnds     )
  deallocate( a_BandNBin        )
  deallocate( ab_BandKeyMolNum  )

  deallocate( a_GaussRegBnds )
  deallocate( cb_BandGaussRegNBin )


  write( 6, * ) "Finish"

#ifdef MPI
  call mpi_finalize( IErr )
#endif

end program main
