program main

  use vtype_module
  use constants0
  use fi_module
  use ni3_module

  use ave_optprop_particle, only : AveOptPropParticle

  implicit none


  character(128) :: CtlFN  = 'sort_ac.conf'
  character(128) :: CtlFN2 = 'sort_ac_atm.conf'
  character(128) :: CtlFN3 = 'sort_ac_file.conf'

  integer :: FileUnit
  integer :: iostat

  integer, parameter :: MaxNmlArySize = 256
  real(8)            :: WNBnds(MaxNmlArySize)
  integer            :: BandNBin(MaxNmlArySize)   ! This is not used.
  integer            :: KeyMolNum(MaxNmlArySize)  ! This is not used.

  integer              :: NBand
  real(8), allocatable :: ab_BandWNBnds    (:,:)

  real(DP)             :: AtmTemp


  character(128) :: PtclOptPropNcFN
  character(128) :: StrSpeNcFN

  character(128) :: InNcFN
  character(128) :: OutNcFN

  integer :: n


  namelist /file_nml/ &
    & StrSpeNcFN, &
    & PtclOptPropNcFN, &
    & OutNcFN
  namelist /atm_nml/ &
    & AtmTemp
  namelist /band_nml/ &
    & NBand, WNBnds, BandNBin, KeyMolNum


  StrSpeNcFN = "strspe.nc"

  InNcFN  = ''

  AtmTemp = 300.0d0

  NBand = 1
  WNBnds    = -999.0d0
  WNBnds(1) = 0.0d0
  WNBnds(2) = 1.0d100

  BandNBin  = 0
  KeyMolNum = 0


  ! Read a namelist file

  call fi_open( CtlFN, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = band_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist band_nml is something wrong.'
  end if
  write( 6, nml = band_nml )
  write( 6, * ) "It should be noticed that BandNBin and KeyMolNum are not used in this program."
  !
  close( FileUnit )

  call fi_open( CtlFN2, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = atm_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist atm_nml is something wrong.'
  end if
  write( 6, nml = atm_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN3, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = file_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist file_nml is something wrong.'
  end if
  write( 6, nml = file_nml )
  !
  close( FileUnit )


  if ( NBand+1 > MaxNmlArySize ) then
    stop 'Array size is too large.'
  end if
  do n = 1, NBand
    if ( WNBnds(n) > WNBnds(n+1) ) then
      stop 'Band bounds does not increase monotonicaly.'
    end if
  end do


  allocate( ab_BandWNBnds     (2,NBand) )
  do n = 1, NBand
    ab_BandWNBnds(1,n) = WNBnds(n  )
    ab_BandWNBnds(2,n) = WNBnds(n+1)
  end do


  call AveOptPropParticle( &
    & StrSpeNcFN, PtclOptPropNcFN, OutNcFN, &
    & AtmTemp, &
    & NBand, ab_BandWNBnds &
    & )

  deallocate( ab_BandWNBnds      )


  write( 6, * ) "Finish"


end program main
