
# Bash script for modification of programs of TIPS 2017
#
# 2017/09/05 yot

#!/bin/bash

ProgFiles=("BD_TIPS_2017_v1p0.for" "BD_MOL_2016.FOR" "BD_ISO_2016.for")

for file in ${ProgFiles[@]}; do
    echo "Modify" ${file} "..."
    filebk=${file}".bk"
    mv ${file} ${filebk}

    cat ${filebk} \
	| sed -e s/Species_2016.cmn/SPECIES_2016.CMN/g \
	| sed -e s/Isotops.cmn/ISOTOPS.CMN/g \
	| sed -e s/MOLEC.cmn/MOLEC.CMN/g \
	| sed -e s/Molec.cmn/MOLEC.CMN/g \
	| sed -e s/BD_ISO_2016.FOR/BD_ISO_2016.for/g \
	      > ${file}

    rm ${filebk}
done

file=${ProgFiles[0]}
echo "Shorten lines in " ${file} "..."
filebk=${file}".bk"
mv ${file} ${filebk}
ruby shortenline.rb -i ${filebk} > ${file}
rm ${filebk}

# check
echo "Checking compile " ${ProgFiles[0]} "..."
gfortran -c ${ProgFiles[0]}

echo "Making symbolic link of" ${ProgFiles[0]} "..."
ln -s ${ProgFiles[0]} "BD_TIPS_2017.f"
