module particle_ec_calc_utils

  use vtype_module

  implicit none

  private

  public :: ParticleECCalcUtilsModifyWavenumberRange

  !----------------------------------------------------------------------------

contains

  !----------------------------------------------------------------------------

  subroutine ParticleECCalcUtilsModifyWavenumberRange( &
    & NProcs, MyRank, &
    & DelWaveNum, &
    & WaveNumS, WaveNumE &
    & )

    integer , intent(in   ) :: NProcs
    integer , intent(in   ) :: MyRank
    real(dp), intent(in   ) :: DelWaveNum
    real(dp), intent(inout) :: WaveNumS
    real(dp), intent(inout) :: WaveNumE


    ! Local variables
    !
    integer :: NWaveNum
    integer :: iRank


    NWaveNum = int( ( WaveNumE - WaveNumS ) / DelWaveNum ) + 1
    WaveNumE = WaveNumS - DelWaveNum
    do iRank = 0, MyRank
      WaveNumS = WaveNumE + DelWaveNum
      WaveNumE = WaveNumS + ( int( NWaveNum / NProcs ) - 1 ) * DelWaveNum
      if ( iRank+1 <= mod( NWaveNum, NProcs ) ) then
        WaveNumE = WaveNumE + DelWaveNum
      end if
    end do


  end subroutine ParticleECCalcUtilsModifyWavenumberRange

  !----------------------------------------------------------------------------

end module particle_ec_calc_utils
